# $Id: MessageList.pm,v 1.7 2002/09/27 03:26:07 red Exp $
# -*- perl -*-
package Pronto::MessageList;
use strict;
use Encode;

use constant TRUE	=> 1;
use constant FALSE	=> 0;

use constant PRIO_COL	=> 0;
use constant ATTACH_COL	=> 1;
use constant MSGNEW_COL	=> 2;
use constant SCORE_COL	=> 3;
use constant FROM_COL	=> 4;
use constant SUBJ_COL	=> 5;
use constant DATE_COL	=> 6;
use constant SERV_COL	=> 7;
use constant HIDDEN_COL	=> 8;
use constant BOLD_COL	=> 9;
use constant MSGID_COL	=> 10;
use constant REPLY_COL  => 11;

sub refresh {
	&refresh_messages;
}

sub refresh_ctree {
	&refresh_messages;
}

sub get_position
{
	my $first = get_last_selected_node_or_row();
#	if ($main::prefs{'messageview'} eq "ctree") {
#		$first = get_node_row($first);
#	}
	return $first;
}	

sub set_position
{
	my ($first) = @_;

	if (not $main::message_clist->get_model->iter_is_valid($first)) { return 0; }
	$main::message_clist->get_selection->select_iter($first);
	$main::message_clist->scroll_to_cell($main::message_clist->get_selection->get_selected_rows, undef, 1, 0.5, 0.5);
	return 1;
	
#	my @rows = $main::message_clist->rows();
#	if (scalar(@rows) > 0) {
#		while ($first >= $main::message_clist->rows) { $first --; }
#		Gtk2::CList::moveto($main::message_clist,$first,0,'0.5','0.5');
#		Gtk2::CList::select_row($main::message_clist,$first,0);
#		if ($first !=0 && $first != -1) {
#			Gtk2::CList::set_focus_row($main::message_clist,$first);
#		}
#	}
}	

sub make_clist {
	my ($recreate)  = @_;
	my($mp_view_raw,@msg_headers,$mp_sep1,$mp_mar,$mp_sep2,
	$mp_plus,$mp_minus,$mp_sep3,$mp_view_header,$mp_nextunread,$mp_add2ab,
	$mp_sep4,$mp_delete,$mp_copy,$mp_move,$mp_view,$selectedmessage,
	$model,$textrenderer,$pixbufrenderer,$column,$colwidget);
	
	if (defined $recreate and $recreate eq "y") {
		$Pronto::FolderMenus::pcp_menus{0}->detach;
		$Pronto::FolderMenus::pmv_menus{0}->detach;
		$main::message_clist->destroy;
		$main::root_window->{'search'}->destroy;
		$main::root_window->{'button'}->destroy;
		$main::root_window->{'scroll2'}->destroy;
		$Pronto::FolderMenus::pcp_items{0} = new Gtk2::MenuItem("Copy");
		$Pronto::FolderMenus::pcp_items{0}->set_submenu($Pronto::FolderMenus::pcp_menus{0});
		$Pronto::FolderMenus::pmv_items{0} = new Gtk2::MenuItem("Move");
		$Pronto::FolderMenus::pmv_items{0}->set_submenu($Pronto::FolderMenus::pmv_menus{0});
	}

	@msg_headers = (" "," "," ",_("Score"), ,_("From"),_("Subject"),_("Date"), _("Server"), _("Hidden Field"));
	if ($main::prefs{'messageview'} eq "clist") {
		$model = Gtk2::ListStore->new('Gtk2::Gdk::Pixbuf', 'Gtk2::Gdk::Pixbuf', 'Gtk2::Gdk::Pixbuf', 'Glib::String', 'Glib::String', 'Glib::String', 'Glib::String', 'Glib::String', 'Glib::Uint', 'Glib::Boolean', 'Glib::Uint', 'Gtk2::Gdk::Pixbuf');
	} elsif ($main::prefs{'messageview'} eq "ctree") {
		$model = Gtk2::TreeStore->new('Gtk2::Gdk::Pixbuf', 'Gtk2::Gdk::Pixbuf', 'Gtk2::Gdk::Pixbuf', 'Glib::String', 'Glib::String', 'Glib::String', 'Glib::String', 'Glib::String', 'Glib::Uint', 'Glib::Boolean', 'Glib::Uint', 'Gtk2::Gdk::Pixbuf');
#		$main::message_clist->set_expander_style($main::prefs{'expander'});
	}
	$model->set_sort_column_id($main::prefs{'SortCol'}, $main::prefs{'SortDir'});
	$model->signal_connect('sort-column-changed', sub {
			my $sortable = shift;
			($main::prefs{'SortCol'}, $main::prefs{'SortDir'}) = $sortable->get_sort_column_id;
		});
	
	$main::message_clist = Gtk2::TreeView->new($model);
	$main::message_clist->get_selection->set_mode('multiple');

	# The priority column
	$pixbufrenderer = Gtk2::CellRendererPixbuf->new;
	$column = Gtk2::TreeViewColumn->new_with_attributes("P", $pixbufrenderer, pixbuf => PRIO_COL);
	$column->set_resizable(FALSE);
	$colwidget = Gtk2::Image->new_from_pixbuf(&main::new_pixbuf('exclamation.xpm'));
	$colwidget->show;
	$column->set_widget($colwidget);
	$column->set_alignment(0.5);
#	$column->set_sort_column_id(PRIO_COL);
	if (not defined $main::prefs{'MessageListColWidth0'}) { $column->set_fixed_width(19); }
		else { $column->set_fixed_width($main::prefs{'MessageListColWidth0'}); }
	if($main::prefs{'prioritycolumn'} eq "n") {
		$column->set_visible(FALSE);
	}
	$main::message_clist->append_column($column);

	# The attachment column
	$pixbufrenderer = Gtk2::CellRendererPixbuf->new;
	$column = Gtk2::TreeViewColumn->new_with_attributes("A", $pixbufrenderer, "pixbuf" => ATTACH_COL);
	$column->set_resizable(FALSE);
	$colwidget = Gtk2::Image->new_from_pixbuf(&main::new_pixbuf('paperclip.xpm'));
	$colwidget->show;
	$column->set_widget($colwidget);
	$column->set_alignment(0.5);
#	$column->set_sort_column_id(ATTACH_COL);
	if (not defined $main::prefs{'MessageListColWidth1'}) { $column->set_fixed_width(19); }
		else { $column->set_fixed_width($main::prefs{'MessageListColWidth1'}); }
	if($main::prefs{'attachcolumn'} eq "n" ) {
		$column->set_visible(FALSE);
	}
	$main::message_clist->append_column($column);
	
	# The new-message-marker column
	$pixbufrenderer = Gtk2::CellRendererPixbuf->new;
	$column = Gtk2::TreeViewColumn->new_with_attributes("N", $pixbufrenderer, "pixbuf" => MSGNEW_COL);
	$column->set_resizable(TRUE);
	$colwidget = Gtk2::Image->new_from_pixbuf(&main::new_pixbuf('newm.xpm'));
	$colwidget->show;
	$column->set_widget($colwidget);
	$column->set_alignment(0.5);
#	$column->set_sort_column_id(MSGNEW_COL);
	if (not defined $main::prefs{'MessageListColWidth2'}) { $column->set_fixed_width(19); }
		else { $column->set_fixed_width($main::prefs{'MessageListColWidth2'}); }
	if($main::prefs{'msgnewcolumn'} eq "n" ) {
		$column->set_visible(FALSE);
	}
	$main::message_clist->append_column($column);
	
	# The scoring column
	$textrenderer = Gtk2::CellRendererText->new;
	$textrenderer->set('font-desc' => Gtk2::Pango::FontDescription->from_string($main::prefs{'FontMLNormal'}));
	$textrenderer->set('weight' => $main::bold);
	$column = Gtk2::TreeViewColumn->new_with_attributes($msg_headers[3], $textrenderer, 
			'text' => SCORE_COL, 'weight_set' => BOLD_COL);
	$column->set_resizable(1);
	$column->set_alignment(0.5);
	$column->set_sizing('fixed');
	$column->set_sort_column_id(SCORE_COL);
	if (not defined $main::prefs{'MessageListColWidth3'}) { $column->set_fixed_width(25); }
		else { $column->set_fixed_width($main::prefs{'MessageListColWidth3'}); }
	if (defined $main::prefs{'Scoring'} && $main::prefs{'Scoring'} eq "n") {
		$column->set_visible(FALSE);
	}
	$main::message_clist->append_column($column);
	
	# The from column
	$textrenderer = Gtk2::CellRendererText->new;
	$textrenderer->set('font-desc' => Gtk2::Pango::FontDescription->from_string($main::prefs{'FontMLNormal'}));
	$textrenderer->set('weight' => $main::bold);
	$column = Gtk2::TreeViewColumn->new_with_attributes($msg_headers[4], $textrenderer, 
			'text' => FROM_COL, 'weight_set' => BOLD_COL);
	$column->set_resizable(1);
	$column->set_sizing('fixed');
	$column->set_sort_column_id(FROM_COL);
	if (not defined $main::prefs{'MessageListColWidth4'}) { $column->set_fixed_width(127); }
		else { $column->set_fixed_width($main::prefs{'MessageListColWidth4'}); }
	$main::message_clist->append_column($column);

	# The subject column
	my $pixtext_renderer = Pronto::CellRendererPixText->new;
	$pixtext_renderer->set('font-string' => $main::prefs{'FontMLNormal'});
	$pixtext_renderer->set('weight' => 'bold');
	$column = Gtk2::TreeViewColumn->new_with_attributes($msg_headers[5], $pixtext_renderer, 
			'text' => SUBJ_COL, 'weight_set' => BOLD_COL, 'pixbuf' => REPLY_COL);
	$column->set_resizable(1);
	$column->set_sizing('fixed');
	$column->set_sort_column_id(SUBJ_COL);
	if (not defined $main::prefs{'MessageListColWidth5'}) { $column->set_fixed_width(175); }
		else { $column->set_fixed_width($main::prefs{'MessageListColWidth5'}); }
	$main::message_clist->append_column($column);
	if ($main::prefs{'messageview'} eq "ctree") {
		$main::message_clist->set_expander_column($column);
	}

	# A hidden column for message date in seconds
	$textrenderer = Gtk2::CellRendererText->new;
	$textrenderer->set('font-desc' => Gtk2::Pango::FontDescription->from_string($main::prefs{'FontMLNormal'}));
	$textrenderer->set('weight' => $main::bold);
	$column = Gtk2::TreeViewColumn->new_with_attributes($msg_headers[6], $textrenderer, 
			'text' => DATE_COL, 'weight_set' => BOLD_COL);
	$column->set_resizable(1);
	$column->set_sort_column_id(HIDDEN_COL);
	$column->set_sizing('fixed');
	if (not defined $main::prefs{'MessageListColWidth6'}) { $column->set_fixed_width(175); }
		else { $column->set_fixed_width($main::prefs{'MessageListColWidth6'}); }
	if ($main::prefs{'servercolumn'} eq "n") {
		# Set sizing to autosize if this is the last visible column
		$column->set_sizing('autosize');
	}
	$main::message_clist->append_column($column);

	# The server column
	$textrenderer = Gtk2::CellRendererText->new;
	$textrenderer->set('font-desc' => Gtk2::Pango::FontDescription->from_string($main::prefs{'FontMLNormal'}));
	$textrenderer->set('weight' => $main::bold);
	$column = Gtk2::TreeViewColumn->new_with_attributes($msg_headers[7], $textrenderer, 
			'text' => SERV_COL, 'weight_set' => BOLD_COL);
	$column->set_resizable(1);
	$column->set_sort_column_id(SERV_COL);
	$column->set_sizing('fixed');
	if (not defined $main::prefs{'MessageListColWidth7'}) { $column->set_fixed_width(175); }
		else { $column->set_fixed_width($main::prefs{'MessageListColWidth7'}); }
	if ($main::prefs{'servercolumn'} eq "n") {
		$column->set_visible(FALSE);
	} else {
		# Set sizing to autosize if this is the last visible column
		$column->set_sizing('autosize');
	}
	$main::message_clist->append_column($column);

#	@{$main::message_clist->{'labels'}} = @msg_headers;
	$main::message_clist->{'name'} = "message";

	$main::message_clist->set_search_column(SUBJ_COL);
	$main::message_clist->set_enable_search(1);

#	for (my $i = 0; $i < 7; $i++) {
#		if (defined $main::prefs{'MessageListColWidth' . $i}) {
#			$main::message_clist->get_column($i)->set_fixed_width($main::prefs{'MessageListColWidth' . $i});
#		}
#	 }
	
#	$main::message_clist->set_row_height(17);
#	$main::message_clist->signal_connect('click_column', \&click_column);
	$main::message_clist->signal_connect('button_press_event',\&click_clist);
	$main::message_clist->signal_connect('cursor-changed', sub {
			&main::selection_handler($_[0], [$main::root_window->{'html_view'}, $main::attach_menu, $main::view_attach_menu, $main::root_window->{'table1'}]);
		});
#	$main::message_clist->signal_connect('key_press_event', \&key_pressed);
#	$main::message_clist->signal_connect("resize-column" => sub {my ($d, $c, $w)=@_; $main::prefs{'MessageListColWidth'. $c}=$w;});
	
	$main::root_window->{'scroll2'} = new Gtk2::ScrolledWindow(undef,undef);
	$main::root_window->{'scroll2'}->set_policy('automatic','automatic');
	$main::root_window->{'scroll2'}->set_shadow_type('etched-in');
	if ($main::prefs{'Layout'} == 2) {
		my ($swidth,$sheight) = &main::get_win_size("secondPane",225,125);
		$main::root_window->{'scroll2'}->set_size_request($swidth,$sheight);
		$main::root_window->{'scroll2'}->signal_connect("size-allocate" => \&main::save_sizepane2);
	}								
	$main::root_window->{'scroll2'}->add($main::message_clist);
	$main::root_window->{'search'} = new Gtk2::Button(_("Search"));
	$main::root_window->{'button'} = new Gtk2::HBox(0,0);
	$main::root_window->{'button'}->show;
	$main::root_window->{'button'}->pack_start($main::root_window->{'search'},1,1,5);
	$main::root_window->{'search'}->signal_connect("clicked" =>\&Pronto::Search::search_win);
	$main::message_clist->{'popup'} = new Gtk2::Menu;
#	$mp_sep1 = new Gtk2::MenuItem;
#	$main::message_clist->{'popup'}->append($mp_sep1);

	# Set up the pixbufs for the symbols in the MessageList
	$main::message_clist->{'pix'}->{'newm'} = &main::new_pixbuf('newm.xpm');
	$main::message_clist->{'pix'}->{'replyf'} = &main::new_pixbuf('reply_flag.xpm');
	$main::message_clist->{'pix'}->{'forwardf'} = &main::new_pixbuf('forward_flag.xpm');
	$main::message_clist->{'pix'}->{'paperclip'} = &main::new_pixbuf('paperclip.xpm');
#	$main::message_clist->{'pix'}->{'key'} = &main::new_pixbuf('key.xpm');
	$main::message_clist->{'pix'}->{'exclamation'} = &main::new_pixbuf('exclamation.xpm');
	$main::message_clist->{'pix'}->{'dummy'} = Gtk2::Gdk::Pixbuf->new('GDK_COLORSPACE_RGB', 1, 8, 1, 1);
	
	if ($main::prefs{'messageview'} eq "ctree") {
		my $collapse = new Gtk2::MenuItem(_("Collapse Threads .."));
		$collapse->signal_connect("activate", sub { $main::message_clist->collapse_all });
		$main::message_clist->{'popup'}->append($collapse);
		my $expand = new Gtk2::MenuItem(_("Expand Threads .."));
		$expand->signal_connect("activate", sub { $main::message_clist->expand_all });
		$main::message_clist->{'popup'}->append($expand);
		my $sep = new Gtk2::MenuItem;
		$main::message_clist->{'popup'}->append($sep);
	}
 
	$mp_mar = new Gtk2::MenuItem(_("Mark as Read .."));
	$mp_mar->signal_connect("activate", sub { &Pronto::Data::Message::mark_as_read("read") });
	$main::message_clist->{'popup'}->append($mp_mar);
	my $mp_mar_unread = new Gtk2::MenuItem(_("Mark as Unread .."));
	$mp_mar_unread->signal_connect("activate", sub { &Pronto::Data::Message::mark_as_read("unread") });
	$main::message_clist->{'popup'}->append($mp_mar_unread);
	$mp_sep2 = new Gtk2::MenuItem();
	$main::message_clist->{'popup'}->append($mp_sep2);
	$mp_plus = new Gtk2::MenuItem(_("Score +1"));
	$main::message_clist->{'popup'}->append($mp_plus);
	$mp_minus = new Gtk2::MenuItem(_("Score -1"));
	$main::message_clist->{'popup'}->append($mp_minus);
	$mp_sep3 = new Gtk2::MenuItem();
	$main::message_clist->{'popup'}->append($mp_sep3);
	$mp_view = new Gtk2::MenuItem(_("Open in a view win"));
	$main::message_clist->{'popup'}->append($mp_view);
	$mp_view_header = new Gtk2::MenuItem(_("View Header"));
	$main::message_clist->{'popup'}->append($mp_view_header);
	$mp_view_raw = new Gtk2::MenuItem(_("View Source"));
	$main::message_clist->{'popup'}->append($mp_view_raw);
	$mp_add2ab = new Gtk2::MenuItem(_("Add to Addressbook"));
	$main::message_clist->{'popup'}->append($mp_add2ab);
	$mp_sep4 = new Gtk2::MenuItem;
	$main::message_clist->{'popup'}->append($mp_sep4);
	my $refilter = new Gtk2::MenuItem(_("Refilter"));
	$refilter->signal_connect("activate" => \&Pronto::Data::Message::refilter);
	$main::message_clist->{'popup'}->append($refilter);
	$mp_delete = new Gtk2::MenuItem(_("Delete"));
	$mp_delete->signal_connect("activate" => \&Pronto::MainWindow::handle_delete_msgs);
	$main::message_clist->{'popup'}->append($mp_delete);

	my $serverstatmenu = new Gtk2::Menu;
	$serverstatmenu->{'ServerLeave'} = new Gtk2::MenuItem(_("Leave on server"));
	$serverstatmenu->{'ServerLeave'}->signal_connect("activate", sub { &Pronto::MainWindow::handle_msgs_server_status(2) });
	$serverstatmenu->{'ServerFetch'} = new Gtk2::MenuItem(_("Fetch from server"));
	$serverstatmenu->{'ServerFetch'}->signal_connect("activate", sub { &Pronto::MainWindow::handle_msgs_server_status(4) });
	$serverstatmenu->{'ServerFetchDelete'} = new Gtk2::MenuItem(_("Fetch & Delete"));
	$serverstatmenu->{'ServerFetchDelete'}->signal_connect("activate", sub { &Pronto::MainWindow::handle_msgs_server_status(5) });
	$serverstatmenu->{'ServerDelete'} = new Gtk2::MenuItem(_("Delete from server"));
	$serverstatmenu->{'ServerDelete'}->signal_connect("activate", sub { &Pronto::MainWindow::handle_msgs_server_status(3) });
	$serverstatmenu->append($serverstatmenu->{'ServerLeave'});
	$serverstatmenu->append($serverstatmenu->{'ServerFetch'});
	$serverstatmenu->append($serverstatmenu->{'ServerFetchDelete'});
	$serverstatmenu->append($serverstatmenu->{'ServerDelete'});
	my $mp_servermenu = new Gtk2::MenuItem(_("Server Status"));
	$mp_servermenu->set_submenu($serverstatmenu);
	$main::message_clist->{'popup'}->append($mp_servermenu);
	
	$main::message_clist->{'popup'}->append($Pronto::FolderMenus::pcp_items{0});
	$main::message_clist->{'popup'}->append($Pronto::FolderMenus::pmv_items{0});
	my $filtermenu = new Gtk2::Menu;
	$filtermenu->{'from'} = new Gtk2::MenuItem(_("Based on From"));
	$filtermenu->{'from'}->signal_connect("activate", sub { &Pronto::Filter::filter_editwin(undef, [undef,"newfromlist",undef,"from"]) });
	$filtermenu->{'to'} = new Gtk2::MenuItem(_("Based on To"));
	$filtermenu->{'to'}->signal_connect("activate", sub { &Pronto::Filter::filter_editwin(undef, [undef,"newfromlist",undef,"to"]);});
	$filtermenu->{'subject'}=new Gtk2::MenuItem(_("Based on Subject"));
	$filtermenu->{'subject'}->signal_connect("activate", sub { &Pronto::Filter::filter_editwin(undef,[undef,"newfromlist",undef,"subject"]);});
	$filtermenu->append($filtermenu->{'from'});
	$filtermenu->append($filtermenu->{'to'});
	$filtermenu->append($filtermenu->{'subject'});
	my $mp_filter = new Gtk2::MenuItem(_("Create Filter"));
	$mp_filter->set_submenu($filtermenu);
	$main::message_clist->{'popup'}->append($mp_filter);
	$main::message_clist->{'popup'}->show_all;
	$mp_view->signal_connect("activate", sub { &Pronto::Read::message_view_win(undef,1);});
	$mp_view_header->signal_connect("activate" =>, sub {Pronto::Read::head_view(3)});
	$mp_view_raw->signal_connect("activate" => \&Pronto::Read::view_raw);
	$mp_plus->signal_connect("activate" => \&Pronto::Data::Message::scoring, [$main::message_clist, "up"]);
	$mp_minus->signal_connect("activate" => \&Pronto::Data::Message::scoring, [$main::message_clist, "down"]);
	$mp_add2ab->signal_connect("activate" => \&Pronto::Data::Message::clist2ab);
	if (defined $recreate and $recreate eq "y") { 
		$main::root_window->{'scroll2'}->show;
		$main::root_window->{'search'}->show;
		$main::root_window->{'message_vbox'}->pack_start($main::root_window->{'scroll2'},1,1,0);
		$main::root_window->{'message_vbox'}->pack_start($main::root_window->{'button'},0,0,0);
		$main::message_clist->show 
	}
return 1;
}

sub make_clist_sigs {
	
	my ($clipmask,$clip,$pixmap,$mask,$exclame,$newm,$newm_mask,$newmp,$clippixmap);
	if ($main::prefs{'Drag'}) {
		&main::set_clist_drag_signals();
	}	
return 1;
  	if ($main::prefs{'messageview'} eq "clist") {
		 $main::message_clist->signal_connect('select_row', \&main::selection_handler,
        	 	[$main::root_window->{'html_view'}, $main::attach_menu, $main::view_attach_menu, $main::root_window->{'table1'}]);
	} elsif ($main::prefs{'messageview'} eq "ctree") {
	$main::message_clist->signal_connect('tree_select_row', \&main::selection_handler,
        	$main::root_window->{'html_view'}, $main::attach_menu, $main::view_attach_menu, $main::root_window->{'table1'});
	}
	
	if ($main::prefs{'Drag'}) {
		&main::set_clist_drag_signals();
	}	
	       
	
 	if(-f "$main::prefs{'PixmapDir'}/paperclip.xpm") {
 		($main::root_window->{'clippixmap'},$main::root_window->{'clipmask'})=Gtk2::Gdk::Pixmap->create_from_xpm($main::message_clist->clist_window,$main::message_clist->style->bg('normal'), "$main::prefs{'PixmapDir'}/paperclip.xpm");
 	}
 	else {
		($main::root_window->{'clippixmap'},$main::root_window->{'clipmask'})=Gtk2::Gdk::Pixmap->create_from_xpm_d($main::message_clist->clist_window,$main::message_clist->style->bg('normal'), @main::dummy_pixmap);
 	}
 	$main::root_window->{'clip'} = new Gtk2::Pixmap($main::root_window->{'clippixmap'}, $main::root_window->{'clipmask'});
 	$main::message_clist->set_column_widget(1, $main::root_window->{'clip'});
 	if(-f "$main::prefs{'PixmapDir'}/exclamation.xpm") {
		($main::root_window->{'pixmap'},$main::root_window->{'mask'})=Gtk2::Gdk::Pixmap->create_from_xpm($main::message_clist->clist_window,$main::message_clist->style->bg('normal'),"$main::prefs{'PixmapDir'}/exclamation.xpm");
	 }
	 else {
		($main::root_window->{'pixmap'},$main::root_window->{'mask'})=Gtk2::Gdk::Pixmap->create_from_xpm_d($main::message_clist->clist_window,$main::message_clist->style->bg('normal'),@main::dummy_pixmap);
 	}
 	$main::root_window->{'exclame'} = new Gtk2::Pixmap($main::root_window->{'pixmap'}, $main::root_window->{'mask'});
 	$main::message_clist->set_column_widget(0, $main::root_window->{'exclame'});
 	if(-f "$main::prefs{'PixmapDir'}/newm.xpm") {
		($main::root_window->{'newm'},$main::root_window->{'newm_mask'}) = Gtk2::Gdk::Pixmap->create_from_xpm($main::message_clist->clist_window,$main::message_clist->style->bg('normal'),"$main::prefs{'PixmapDir'}/newm.xpm");
	 }
	 else {
		($main::root_window->{'newm'},$main::root_window->{'newm_mask'}) = Gtk2::Gdk::Pixmap->create_from_xpm_d($main::message_clist->clist_window,$main::message_clist->style->bg('normal'),@main::dummy_pixmap); }
	 $main::root_window->{'newmp'} = new Gtk2::Pixmap($main::root_window->{'newm'},$main::root_window->{'newm_mask'});
	 $main::message_clist->set_column_widget(2, $main::root_window->{'newmp'});
	 if ($main::prefs{'messageview'} eq "clist") {
		 &click_column($main::message_clist, $main::message_clist->{'sortcol'});
	} elsif ($main::prefs{'messageview'} eq "ctree") {
		$main::message_clist->set_sort_column ( $main::prefs{'SortCol'} );
		&ctree_click_column($main::message_clist, $main::message_clist->{'sortcol'});
	}

	return 1;
}


sub expand_threads {
	my ($widget) = @_;
	if ($widget->get_active) { 
		$main::prefs{'threadpref'} = "expanded";
		$main::message_clist->expand_all;
	} else {
		$main::prefs{'threadpref'} = "collapsed";
		$main::message_clist->collapse_all;
	}
     
	return 1;
}

sub refresh_messages {
	if (defined $main::folder_tree->{'has_been_reordered'}) { 
		# I cannot refresh the MessageList right now, as a folder has
		# been dragged around and @main::ft_node hasn't been updated yet.
		return 0; 
	}
	my ($switch) = @_; # IMHO, this "switch" flag isn't needed anymore. (by Florian)

	my ($vpos, @selected_iters);
	my %selected_ids = ();
	for (&get_selected_msgids) { $selected_ids{$_} = 1; };
	$vpos = $main::message_clist->get_vadjustment;
	foreach(keys(%main::folderidtoname)) {
		if ($_ >= 1000) {
			if ($main::folder_tree->get_model->iter_is_valid($main::ft_node[$_])) {
				# Just another sanity check...
				$main::folder_tree->get_model->set($main::ft_node[$_], 1, "");
				$main::folder_tree->get_model->set($main::ft_node[$_], 2, "");
			}
		}
	}

	my $box = &Pronto::FolderTree::get_folder_id();
	if (defined $box and $box == 0) { $main::message_clist->get_model->clear(); &main::set_win_title }
	if (!$box) { return 1 }
	if ($main::mark_timer) { Glib::Source->remove($main::mark_timer); }	
	if ($box != 1000) { if ($main::root_window->{'button'}->visible()) {$main::root_window->{'button'}->hide} }
	if ($box > 1000) { &Pronto::Search::view_virtual_folder($box); return 1; } 
	if ($box == 1000) {  $main::root_window->{'button'}->show } 
	if (($box != 3) and ($box != 2) and ($box != 5)) {
		$main::message_clist->get_column(FROM_COL)->set('title', _("From"));
	} else { 
		$main::message_clist->get_column(FROM_COL)->set('title', _("To"));
	}

	$main::message_clist->get_model->clear;	

	my($sql,$sth);
	$sql = "select msgid,inreplyto,subject,friendly,localdate,id,newmsg,replyf,priority,contenttype,score,ref,serverstat from messages where boxid = '$box' order by localdate";# order by inreplyto,ref"; 
	$sth = $main::conn->prepare($sql);
	$sth->execute();

	my %nodes = ();
	my $noderef = \%nodes;
	my $iter = undef;
	while (my @row = $sth->fetchrow_array()) {
		my $id   = $row[5];

		# Handle UTF-8 data in the header fields
		my $utf8_version;
		eval "\$utf8_version = decode( 'utf8', \$row[2], Encode::FB_CROAK )";
		if (not $@) { $row[2] = $utf8_version; }
		eval "\$utf8_version = decode( 'utf8', \$row[3], Encode::FB_CROAK )";
		if (not $@) { $row[3] = $utf8_version; }
		
		($iter, $noderef) = &append_message_to_messagelist($noderef, @row);
			
		if (defined $selected_ids{$id}) { push @selected_iters, $iter; }
	}

	if ($main::prefs{'threadpref'} eq "expanded") { $main::message_clist->expand_all; }
		else { $main::message_clist->collapse_all; }

	foreach (@selected_iters) {
		my $path = $main::message_clist->get_model->get_path($_);
		$path->up;
		$main::message_clist->expand_to_path($path);
		$main::message_clist->get_selection->select_iter($_);
	}
	$main::message_clist->set_vadjustment($vpos);

	&main::set_win_title;

	return 1;
}

sub append_message_to_messagelist {
	my ($noderef, $msgid, $inreplyto, $subject, $sentfrom, $date, $id, $newmsg, $reply, $priority, $contenttype, $score, $ref, $serverstat) = @_;

	my $iter  = undef;
	my $model = $main::message_clist->get_model;

	my $sub = $subject;
	$sub =~ s!\bre(:|\b)\s+!!gi;		
	if (not defined $score) { $score = 0 }
	if ($score == 0) { $score = " "; }
	 #shut CSV up
        if ($main::prefs{'DatabaseDriver'} eq "CSV") {
		if (not defined $reply or $reply eq "") {
			$reply = 0;
		}
	}
	if (defined $serverstat && $serverstat == 1) {
		$serverstat = _("Not Fetched");	# Message is still on server and has NOT been fetched.
	} elsif (defined $serverstat && ($serverstat == 2 || $serverstat == 6)) {
		$serverstat = _("On Server"); 	# Message is still on server and has been fetched. 
	} elsif (defined $serverstat && $serverstat == 3) { 
		$serverstat = _("To Be Deleted");	# Message is flagged for deletion. 
	} elsif (defined $serverstat && $serverstat == 4) { 
		$serverstat = _("To Be Fetched");	# Message is flagged for fetching. 
	} elsif (defined $serverstat && $serverstat == 5) { 
		$serverstat = _("To Be Fetched & Deleted");# Message is flagged for fetch & delete. 
	} else { 
		$serverstat = " ";	# Message is not on server.
	}

	if ($main::prefs{'messageview'} eq "ctree") {
		if ($main::prefs{'threadbysubject'} && $main::prefs{'threadbysubject'} eq "y") {
			($iter, $subject, $noderef) = &create_nodes_by_subject_thread($model, $msgid, $sentfrom, $date, $subject, $sub, $noderef);
		}
		else {
			($iter, $subject, $noderef) = &create_nodes_by_ref_thread($model, $msgid, $sentfrom, $date, $subject, $sub, $ref, $inreplyto, $noderef);
		}
	} else {
		$iter = $model->append;
	}

	if (defined $reply and $reply ne "" and $reply == 1) {
		$model->set($iter, REPLY_COL, $main::message_clist->{'pix'}->{'replyf'});
	} elsif (defined $reply and $reply ne "" and $reply == 2) {
		$model->set($iter, REPLY_COL, $main::message_clist->{'pix'}->{'forwardf'});
	} else {
		$model->set($iter, REPLY_COL, $main::message_clist->{'pix'}->{'dummy'});
	}

	$model->set($iter, 
			SCORE_COL,	$score,
			FROM_COL,	$sentfrom,
			SUBJ_COL,	$subject,
			DATE_COL,	&main::localdate_to_displaydate($date),
			SERV_COL,	$serverstat,
			HIDDEN_COL,	$date,
			MSGID_COL,	$id
		);

	if ($contenttype && ($contenttype !~ /(text|alternative|multipart\/report)/i)) { 
		if (($contenttype !~ /multipart\/signed/i) || 
		    ($contenttype =~ /multipart\/signed.*;;.*multipart/ims)) {
			$model->set($iter, ATTACH_COL, $main::message_clist->{'pix'}->{'paperclip'});
		}
	}
	if (($priority) and ($priority =~ /high/i)) {
		$model->set($iter, PRIO_COL, $main::message_clist->{'pix'}->{'exclamation'});
	}
	if (defined $newmsg and $newmsg eq "y") {
		$model->set($iter, MSGNEW_COL, $main::message_clist->{'pix'}->{'newm'});
		if ($main::prefs{'BoldMsg'}) {
			$model->set($iter, BOLD_COL, TRUE);
		}
	} else {
		if ($main::prefs{'BoldMsg'}) {
			$model->set($iter, BOLD_COL, FALSE);
		}
	}	

	return $iter, $noderef;
}

sub create_nodes_by_ref_thread {
	my ($model, $msgid, $sentfrom, $date, $subject, $sub, $ref, $inreplyto, $noderef) = @_;
	my %nodes = %$noderef;
	my $iter;

	if (!$ref && !$inreplyto) { #toplevel mail
		$iter = $model->insert_after(undef, undef);
		$nodes{$msgid} = $iter;
		$nodes{$sentfrom . $date} = $iter;
		$nodes{$sub} = $iter;
	} else {
		if (!$ref && $inreplyto =~ /^(.+)\'s message of \"([^\"]+)\"/) {
			$inreplyto = "$1$2";
			$inreplyto =~ s/\"//g;
		} elsif ($ref =~ /(<[^>]+>)$/ || $inreplyto =~ /(<[^>]+>)/) {
			$inreplyto = $1;
		}

		# enhanced ref parsing, by Florian
		if (!$nodes{$inreplyto}) {
			$ref =~ s/></> </g;
			my @refs = split(/ /, $ref);
			my $lastref = pop @refs;
			while ((!$nodes{$lastref}) && (@refs > 0)) { $lastref = pop @refs; }
			if ($nodes{$lastref}) { $inreplyto = $lastref; }
		}

		if ($nodes{$inreplyto}) {
			if ($main::prefs{'arrowthreads'} eq "y") { $subject = $main::prefs{'threadarrow'}; }
			$iter = $model->insert_before($nodes{$inreplyto}, undef);
			$nodes{$msgid} = $iter;
			$nodes{$sentfrom . $date} = $iter;
			$nodes{$sub} = $iter;
		} elsif ($nodes{$sub} && $main::prefs{'GuessRejectThreads'} eq "y") {
			if ($main::prefs{'arrowthreads'} eq "y") { $subject = $main::prefs{'threadarrow'}; }
			$iter = $model->insert_before($nodes{$sub}, undef);
			$nodes{$msgid} = $iter;
			$nodes{$sentfrom . $date} = $iter;     
			$nodes{$sub} = $iter;
		} else {
			$iter = $model->insert_after(undef, undef);
			$nodes{$msgid} = $iter;
			$nodes{$sentfrom . $date} = $iter;
			$nodes{$sub} = $iter;
		}
	}

	return ($iter, $subject, \%nodes);
}

sub create_nodes_by_subject_thread {
	my ($model, $msgid, $sentfrom, $date, $subject, $sub, $noderef) = @_;
	my %nodes = %$noderef;
	my $iter;
	
	if (!$nodes{$sub}) { #toplevel mail
		$iter = $model->insert_after(undef, undef);
		$nodes{$msgid} = $iter;
		$nodes{$sentfrom . $date} = $iter;    
		$nodes{$sub} = $iter;
	} 
	elsif ($nodes{$sub} and $subject =~ /\bre(:|\b)/ig) {
	 	if ($main::prefs{'arrowthreads'} eq "y") { $subject = $main::prefs{'threadarrow'}; }
		$iter = $model->insert_before($nodes{$sub}, undef);
		$nodes{$msgid} = $iter;
		$nodes{$sentfrom . $date} = $iter;     
		$nodes{$sub} = $iter;
	} else {
		$iter = $model->insert_after(undef, undef);
		$nodes{$msgid} = $iter;
		$nodes{$sentfrom . $date} = $iter;
		$nodes{$sub} = $iter;
	}

	return ($iter, $subject, \%nodes);
}

# This function goes down a TreeStore and checks each row for a certain
# property. It takes three arguments:
# $sub:   A reference to a function that gets called for each row. If it
#         returns true, this is taken as a match and the respective iterator
#         gets returned.
# $store: The model of the TreeStore
# $next:  The first iterator to start the search with, leave it undefined to
#         search from the beginning.
# Return values: A TreeIter in case of a successful match or undef

sub walk_through_store {
	my ($sub, $store, $next) = @_;

	$next = $store->get_iter_first unless $next;

	while (my $iter = $next) {

		return $iter if &$sub($store, $iter);
		
		$next = $store->iter_children($iter) || $store->iter_next($iter);

		until ($next) {	
			last unless $iter = $store->iter_parent($iter);
			$next = $store->iter_next($iter);
		}
			
	}

	return undef;
}

sub is_message_at_iter_new {
	my ($store, $iter) = @_;

	if (not $iter)
	{
		# Use the currently selected message if no iter is given
		my @msgbold;
		$main::message_clist->get_selection->selected_foreach( sub {
			my $model = $_[0];
			my $iter  = $_[2];
			push @msgbold, $model->get($iter, MSGNEW_COL);
		});

		return 1 if ($msgbold[0] and $msgbold[0]->get_width > 1);
		return 0;
	}

	return 1 if ($store->get($iter, MSGNEW_COL) and $store->get($iter, MSGNEW_COL)->get_width > 1);
	return 0;
}

sub goto_next_unread_msg {
	return if $main::dragging;
	my ($current_selection, $path, $model, $iter);
	$model = $main::message_clist->get_model;

        if($main::message_clist->get_selection->count_selected_rows > 0) {
		my @array = $main::message_clist->get_selection->get_selected_rows;
		$path = $array[0];
	}
	if (not $path) {
		$path = Gtk2::TreePath->new_from_indices(0);
	}
	$current_selection = $path->to_string;

	$iter = $model->get_iter($path);
	$iter = &walk_through_store(\&is_message_at_iter_new, $model, $iter);
	if ($iter) { $path = $model->get_path($iter); }
	
	# There is no new message below the currently selected one.
	# Let's search for one from the top again.
	if ((not defined $model->get_iter($path)) or 
	    (not &is_message_at_iter_new($model, $model->get_iter($path)))) {
		$iter = &walk_through_store(\&is_message_at_iter_new, $model);
		if ($iter) { $path = $model->get_path($iter); }
	}
	
	if ((not defined $model->get_iter($path)) or 
	    (not &is_message_at_iter_new($model, $model->get_iter($path)))) {
		return 0 if ($_[1] && $_[1] eq "return if none");
		if (defined $current_selection) {
			$path = Gtk2::TreePath->new_from_string($current_selection);
		} elsif (defined $model->get_iter(Gtk2::TreePath->new_from_indices(0))) {
			$path = Gtk2::TreePath->new_from_indices(0);
		} else {
			$path = undef;
		}
	}

        $main::message_clist->get_selection->unselect_all();
	if(defined $model->get_iter($path)) {
		if ($path->get_depth > 1) {
			my $path_tmp = $path->to_string;
			$path->up; # Otherwise the following child is expanded, too.
			$main::message_clist->expand_to_path($path);
			$path = Gtk2::TreePath->new_from_string($path_tmp);
		}
		$main::message_clist->get_selection->select_path($path);
		$main::message_clist->scroll_to_cell($path, undef, 1, 0.5, 0.5);
		$main::root_window->{'html_view'}->grab_focus;
		&main::selection_handler($main::message_clist, [$main::root_window->{'html_view'}, $main::attach_menu, $main::view_attach_menu, $main::root_window->{'table1'}]);
	}

	return 1;
}

sub click_clist {
	my ($widget, $event) = @_;
	if ($event->type() eq '2button-press') {
		&dblclick_clist($widget, $event);
   	} 

	if (($event->type() eq 'button-press') && ($event->button() == 3) && ($widget->{'popup'})) {
   		$widget->{'popup'}->popup(undef,undef,undef,1,$event->button,$event->time);
		return TRUE;
  	}

	return FALSE;
}

sub dblclick_clist {
  	my ($widget, $event, $data) = @_;
  	my ($x, $y, $flag);
  	$x = $event->x;
  	$y = $event->y;
  	my $path = $widget->get_path_at_pos($x,$y);
  	if (not defined $path) { return 1; }
	my $msgid = $widget->get_model->get($widget->get_model->get_iter($path), MSGID_COL);
	if (!$msgid) { return 1 }
	&Pronto::Read::message_view_win($msgid, 1);
  
  	return 1;
}

# returns the messageid for the first selected message
sub get_selected_msgid
{
	my $msgid;
	return (&get_selected_msgids)[0];
}

sub get_selected_msgids 
{
	my @msgids;
	$main::message_clist->get_selection->selected_foreach( sub {
		my $model = $_[0];
		my $iter  = $_[2];
		push @msgids, $model->get($iter, MSGID_COL);
	});

	return @msgids;
}

sub goto_top
{
	return if $main::dragging;
	$main::message_clist->get_selection->select_path(Gtk2::TreePath->new_from_indices(0));
	&main::selection_handler($main::message_clist, [$main::root_window->{'html_view'}, $main::attach_menu, $main::view_attach_menu, $main::root_window->{'table1'}]);
	
#	$main::message_clist->select_row(0,0);
#	$main::message_clist->moveto(0,0,0.5,0.5);
}

sub get_last_selected_node_or_row
{
	my @iters;
	$main::message_clist->get_selection->selected_foreach( sub {
		my $iter  = $_[2];
		push @iters, $iter;
	});

        return $iters[0];
}	

sub rw_select_all {
	$main::message_clist->get_selection->select_all;
	return 1;
}

sub clear_selection {
	$main::message_clist->get_selection->unselect_all;
	return 1;
}

sub messagelist_drag_data_get
{
	my ($widget, $context, $data, $info, $time) = @_;
#	print "drag data get @_\n";
	return if (!$main::current);
	$data->set($data->target, 8, $main::current);
	return;
}					

sub drag_begin
{
#	print "drag begin @_\n";
	@main::dragged = get_selected_msgids();
	$main::dragging = Pronto::FolderTree::get_folder_id();
	return;
}

sub drag_end
{
#	print "drag end @_\n";
	undef @main::dragged;
	@main::dragged = ();
	$main::dragging = 0;
	return;
}	

####################################################################################
#
# I suppose that functions below this line are not needed any more and
# therefore may be removed. I added '_inac' to their name to see if they are
# really unused. Florian.
#

sub my_sort_func_inac
{
	my ($clist, $first, $second) = @_;
	if ($first =~ /^\d+$/) {
		if ($first > $second) { return -1; }
		if ($first == $second) { return 0; }
		return 2;
	}
	my @stuff = ($first,$second);
	my @sorted = sort {uc($a) cmp uc($b)} @stuff;
	if ($sorted[0] eq $first) { return -1; }
	if ($first eq $second) { return 0; }
	return 2;		
}

sub key_pressed_inac
{
	my ($clist, $event) = @_;
	&Pronto::MainWindow::handle_delete_msgs if ($event->{keyval} == 65535);
	return 1;
}

sub click_column_inac {
	my ($clist, $column) = @_;
	if ($column == $clist->{'sortcol'}) {
		$main::prefs{'SortDir'} = $clist->{'sortdir'};
		if ($clist->{'sortdir'} eq "descending") {
			$clist->{'sortdir'} = "ascending";
		} else {
			$clist->{'sortdir'} = "descending";
		}
	}
	$clist->{'sortcol'} = $column;
	$main::prefs{'SortCol'} = $column;
	if ($clist->{'sortcol'} == 6) {
		$clist->set_sort_column(8);
	} else {
		$clist->set_sort_column($clist->{'sortcol'});
	}
		
	$clist->set_sort_type($clist->{'sortdir'});
	if ($clist->{'sortcol'} == 5) {
		subject_sort($clist);
		return 1;
	}
	$clist->sort;
	&main::set_labels($clist);
	return 1;
}

sub subject_sort_inac
{
	my ($clist) = @_;
	my (%messages);
	$clist->freeze();
	rw_select_all();
	my ($tmp,$id);
	my @msgs = $main::message_clist->selection();
	if (@msgs) {
       		foreach (@msgs) {
       			my $sub = $clist->get_text($_,5);
       			if ($sub) {  
       				$tmp = $sub;
       				$id = ${$clist->get_row_data($_)} if $main::prefs{'messageview'} eq "clist";
				$id = ${$clist->node_get_row_data($_)} if $main::prefs{'messageview'} eq "ctree";
				$messages{$id} = $sub;
       				$tmp =~ s!\bre(:|\b)\s+!!gi; 
       				$clist->set_text($_,5,$tmp);
       			}
       		}
       	}
       	$clist->set_sort_type($clist->{'sortdir'});
	$clist->sort if $main::prefs{'messageview'} eq "clist";
	$clist->sort_recursive(undef) if $main::prefs{'messageview'} eq "ctree";
       	if (@msgs) {
       		foreach (@msgs) {
			$id = ${$clist->get_row_data($_)} if $main::prefs{'messageview'} eq "clist";
			$id = ${$clist->node_get_row_data($_)} if $main::prefs{'messageview'} eq "ctree";
			if ($messages{$id}) {
				$clist->set_text($_,5,$messages{$id});
       			}
		}
       	}	
       	clear_selection();
       	$clist->thaw();
       	&main::set_labels($clist);
       	return 1;
}		

sub ctree_click_column_inac {
	my ($ctree, $column, $data) = @_;
	if ( $column == $ctree->{'sortcol'} ) {      
		$main::prefs{'SortDir'} = $ctree->{'sortdir'};
		if ($ctree->{'sortdir'} eq "ascending") {
			$ctree->{'sortdir'} = "descending";
		} else {
			$ctree->{'sortdir'} = "ascending";
		}
	}
	
	$ctree->{'sortcol'} = $column;
	$main::prefs{'SortCol'} = $column; 
	
	if ($column == 6) { 
		$ctree->set_sort_column(8)
	} else {
		$ctree->set_sort_column($ctree->{'sortcol'});
	}
	
	$ctree->set_sort_type($ctree->{'sortdir'});
	if ($ctree->{'sortcol'} == 5) {
		subject_sort($ctree);
		return 1;
	}
	$ctree->sort_recursive(undef);
	&main::set_labels($ctree);
	return 1;
}

sub ctree_collapse_inac {
        my($widget,$node) = @_;
	new_in_tree($node);
}

sub new_in_tree_inac {
	my($nd,$mark,$check_children) = @_;
	my ($pixmap, $mask) = $main::message_clist->node_get_pixmap($nd,2);
        if(defined $pixmap) {
                return 1;
        }
	if($nd->row->expanded or (defined $check_children and $check_children)) {
        	if(defined $nd->row->children) {
			my $child = $nd->row->children;
       			if(new_in_tree($child,0) || (defined $child->row->sibling && new_in_tree($child->row->sibling,0))) {
   	        		if(not defined $mark or $mark) {
					my ($newm,$newm_mask);
                        		if(-f "$main::prefs{'PixmapDir'}/newm.xpm") {
                       				($newm,$newm_mask)=Gtk2::Gdk::Pixmap->create_from_xpm($main::message_clist->clist_window,$main::message_clist->style->bg('normal'),"$main::prefs{'PixmapDir'}/newm.xpm");
                       			}
                       			else {
                                		($newm,$newm_mask)=Gtk2::Gdk::Pixmap->create_from_xpm_d($main::message_clist->clist_window,$main::message_clist->style->bg('normal'),@main::dummy_pixmap);
                       			}
                       			$main::message_clist->freeze;
                       			$main::message_clist->node_set_pixmap($nd,2,$newm,$newm_mask);
                       			$main::message_clist->thaw;
				}
                       		return 1;
        		}
		}
	}
	return 0;
}

sub ctree_expand_inac {
        my ($tree,$node) = @_;
	my($pixmap,$bitmask) = $main::message_clist->node_get_pixmap($node,2);
	if(defined $pixmap) {
        	my($sql,$query,$msgid);
        	$msgid = ${$main::message_clist->node_get_row_data($node)};
        	$sql = "select newmsg from messages where id=$msgid";
        	$query = $main::conn->prepare($sql);
        	$query->execute();
        	my @newmsg;
        	while(@newmsg=$query->fetchrow_array()) {
                	if($newmsg[0] eq "n") {
                	        $main::message_clist->freeze;
                	        $main::message_clist->node_set_text($node,2,"");
                	        $main::message_clist->thaw;
                	}
        	}
	}
}

sub get_row_inac
{
	my ($select) = @_;	
	if (!$select) { return undef }
	my (@selection);
	if ($main::message_clist->row_list) {
		rw_select_all();
		@selection = $main::message_clist->selection();
	}
	if (@selection) {
		my $i = -1;
		foreach(@selection){
			$i++;
			my $id=${$main::message_clist->get_row_data($_)};
			if ($id == $select) { 
				clear_selection(); 
				return $i;
		       	}
			
		}
	}
	return undef;
}	

sub freeze_inac { $main::message_clist->freeze() }
sub thaw_inac { $main::message_clist->thaw() }
sub rows_inac { return $main::message_clist->rows(); }
sub get_node_row_inac 
{ 
	if (not defined $_[0]) { return undef }
	return $main::message_clist->get_node_position($_[0]);
}

1;
