# $Id: Search.pm,v 1.7 2001/07/23 18:02:32 muhri Exp $
# -*- perl -*-
package Pronto::Search;
use strict;
use SelfLoader;

use constant TRUE	=> 1;
use constant FALSE	=> 0;

use constant PRIO_COL	=> 0;
use constant ATTACH_COL	=> 1;
use constant MSGNEW_COL	=> 2;
use constant SCORE_COL	=> 3;
use constant FROM_COL	=> 4;
use constant SUBJ_COL	=> 5;
use constant DATE_COL	=> 6;
use constant SERV_COL	=> 7;
use constant HIDDEN_COL	=> 8;
use constant BOLD_COL	=> 9;
use constant MSGID_COL	=> 10;
use constant REPLY_COL  => 11;

my $progress = undef;
my $stop = undef;
1;
__DATA__
sub search_win {
	
	my ($search_win, $combo,$tooltips);
	$tooltips = new Gtk2::Tooltips();
	if ($main::prefs{'ToolTips'}) {
		$tooltips->enable();
	} else {
		$tooltips->disable();
	}	
#	$tooltips->set_delay(750);		 
	$search_win = new Gtk2::Window("toplevel");
	$search_win->set_resizable(1);
	$search_win->set('allow-shrink', 1);
	$search_win->set('allow-grow', 1);
	$search_win->set_title(_("Pronto! Search .."));
	$search_win->set_default_size('275','195');
	$search_win->signal_connect("destroy", sub { $search_win->destroy} );
#	$search_win->signal_connect("delete-event" => sub { Gtk2->false } );
	$search_win->set_position(-mouse);
	$search_win->show;
	$search_win->{'vbox'} = new Gtk2::VBox(0,5);
	$search_win->add($search_win->{'vbox'});
	$search_win->{'vbox'}->show;
	
	$search_win->{'hbox'} = new Gtk2::HBox(0,5);
	$search_win->{'hbox'}->show;
	$search_win->{'vbox'}->pack_start($search_win->{'hbox'},0,0,0);
	$search_win->{'label'} = new Gtk2::Label(_("Search by:"));
	$search_win->{'label'}->set_size_request(85,10);
	$search_win->{'label'}->show;
	$combo->{'1'} = new Gtk2::Combo;
	$tooltips->set_tip($combo->{'1'}->entry,_("Choose a field to search by"),"");
	my (@combo1) = ("SentFrom", "Subject", "Date","SentTo","CC","Replyf","NewMsg","Score","All");
	$combo->{'1'}->set_popdown_strings(@combo1);
	$combo->{'1'}->show;
	$combo->{'1'}->list->signal_connect("selection-changed",sub { 
		if ($combo->{'1'}->entry->get_text eq "All") { 
			$search_win->{'entry'}->set_sensitive(0);
			if ($main::prefs{'DatabaseDriver'} ne "CSV") {
				$search_win->{'limit'}->set_sensitive(0);
			}
			$search_win->{'body'}->set_active(1);
		} else { 
			$search_win->{'body'}->set_active(0);
			if ($main::prefs{'DatabaseDriver'} ne "CSV") {
				$search_win->{'limit'}->set_sensitive(1)
			}
			$search_win->{'entry'}->set_sensitive(1) 
	       	}
		if ($combo->{'1'}->entry->get_text eq "SentTo") {
#			${$main::message_clist->{'labels'}}[4] = "To";
#	        	&main::set_labels($main::message_clist);
			$main::message_clist->get_column(FROM_COL)->set_title(_("To"));
	        } else {
#			${$main::message_clist->{'labels'}}[4] = "From";
#	        	&main::set_labels($main::message_clist);
			$main::message_clist->get_column(FROM_COL)->set_title(_("From"));
		}		
		});	
	$search_win->{'for'} = new Gtk2::Label(_("For"));
	$search_win->{'for'}->set_size_request(85,10);
	$search_win->{'for'}->show;
	$search_win->{'entry'} = new Gtk2::Entry;
	$search_win->{'entry'}->set_size_request(170,20);
	$tooltips->set_tip($search_win->{'entry'},_("Enter your search expression here if you are looking for something after a certain word enter as %word"),"");
	$search_win->{'entry'}->show;
	$search_win->{'entry'}->signal_connect("activate" => \&do_search, [$search_win, $combo]);
	$search_win->{'chk1'} = new Gtk2::CheckButton;
	$search_win->{'chk1'}->set_size_request(16,17);
	$search_win->{'chk1'}->show;
	$search_win->{'chk1'}->signal_connect("toggled", sub {
						if ($search_win->{'chk1'}->get_active == 1) {
							$search_win->{'chk2'}->set_active(0);
							$combo->{'2'}->set_sensitive(1);
					      		$search_win->{'entry2'}->set_sensitive(1);
						} else {
							if ($search_win->{'chk2'}->get_active == 1) { 
								return 1;
						       	} else { 
						       		$combo->{'2'}->set_sensitive(0);
						       		$search_win->{'entry2'}->set_sensitive(0)
							}
					      }});
	$search_win->{'and'} = new Gtk2::Label(_("And"));
	$search_win->{'and'}->show;
	$search_win->{'chk2'} = new Gtk2::CheckButton;
	$search_win->{'chk2'}->signal_connect("toggled", sub {
       						if ($search_win->{'chk2'}->get_active == 1) { 
							$search_win->{'chk1'}->set_active(0);							      						$combo->{'2'}->set_sensitive(1);
					      		$combo->{'2'}->set_sensitive(1);
					      		$search_win->{'entry2'}->set_sensitive(1);
						} else {
							if ($search_win->{'chk1'}->get_active == 1) { 
								return 1; 
					      		} else { 
						       		$combo->{'2'}->set_sensitive(0);
					      	       		$search_win->{'entry2'}->set_sensitive(0);
							}
					      }});
	$search_win->{'chk2'}->set_size_request(16,17);
	$search_win->{'chk2'}->show;
	$search_win->{'or'} = new Gtk2::Label(_("Or "));
	$search_win->{'or'}->show;
	my (@combo2) = ("SentFrom","Sentto","CC","Date","Subject","BoxName","ReplyF","Score","NewMsg");
	$combo->{'2'} = new Gtk2::Combo;
	$combo->{'2'}->set_popdown_strings(@combo2);
	$combo->{'2'}->show;
	$combo->{'2'}->list->signal_connect("selection-changed", sub {
						if ($combo->{'2'}->entry->get_text eq "BoxName") {
							$search_win->{'entry2'}->hide;
						        $search_win->{'for2'}->set_text("Is");
					       		$combo->{'3'}->show;
						 } else { 
						  	$search_win->{'entry2'}->show;
						  	$search_win->{'for2'}->set_text("For");
						  	$combo->{'3'}->hide;
						 }
						  });
	$combo->{'2'}->set_sensitive(0);
	$search_win->{'for2'} = new Gtk2::Label(_("For"));
	$search_win->{'for2'}->set_size_request(85,10);
	$search_win->{'for2'}->show;
	$search_win->{'entry2'} = new Gtk2::Entry;
      	$search_win->{'entry2'}->set_sensitive(0);
	$search_win->{'entry2'}->set_size_request(170,20);
	$search_win->{'entry2'}->signal_connect("activate" =>\&do_search, [$search_win, $combo]);
	$search_win->{'entry2'}->show;
	$combo->{'3'} = new Gtk2::Combo;
	my @boxlist = sort(keys(%main::foldernametoid));
	$combo->{'3'}->set_popdown_strings(@boxlist);
	$combo->{'3'}->hide;
	$search_win->{'limitlbl'} = new Gtk2::Label(_("Limit"));
	$search_win->{'limitlbl'}->set_size_request(85,10);
	$search_win->{'limitlbl'}->show;
	$search_win->{'limit'} = new Gtk2::Combo;
	$tooltips->set_tip($search_win->{'limit'}->entry,_("Set the limit to number of results - not supported for CSV"),"");
	my (@limits) = ("Unlimited", "10", "20","30","40","50");
	$search_win->{'limit'}->set_popdown_strings(@limits);
	$search_win->{'limit'}->show;
	if ($main::prefs{'DatabaseDriver'} eq "CSV") {
		$search_win->{'limit'}->set_sensitive(0);
	}
	$search_win->{'bodylabel'} = new Gtk2::Label(_("Search body for"));
	$search_win->{'bodylabel'}->show;
	$search_win->{'body'} = new Gtk2::CheckButton;
	$search_win->{'body'}->set_size_request(16,17);
	$search_win->{'body'}->show;
	$search_win->{'body'}->set_active(0);
	$search_win->{'body'}->signal_connect("toggled", sub { 
							if ($search_win->{'body'}->get_active) {
								$search_win->{'bodytext'}->set_sensitive(1);
			       				} else {
								$search_win->{'bodytext'}->set_sensitive(0);
							}
							});
							
	$search_win->{'bodytext'} = new Gtk2::Entry;
	$tooltips->set_tip($search_win->{'bodytext'},_("Enter words to search for in the message body"));
	$search_win->{'bodytext'}->set_editable(1);
	$search_win->{'bodytext'}->set_sensitive(0);
	$search_win->{'bodytext'}->show;
	$search_win->{'bodytext'}->signal_connect("activate" => \&do_search, [$search_win, $combo]);
	$search_win->{'button'} = new Gtk2::Button(_("Go"));
	$tooltips->set_tip($search_win->{'button'},_("Execute Search"),"");
	$search_win->{'button'}->signal_connect("clicked" => \&do_search, [$search_win, $combo]);
	$search_win->{'button'}->show;
	$search_win->{'save'} = new Gtk2::Button(_("Save into a vfolder"));
	$tooltips->set_tip($search_win->{'save'},_("If you are satisfied with your search results, you can save it as a VFolder for immediate retrival later on"),"");
	$search_win->{'save'}->show;
	$search_win->{'save'}->signal_connect("clicked" => \&save_vf, [$search_win, $combo]);
	$search_win->{'hbox'}->pack_start($search_win->{'label'},0,0,0);
	$search_win->{'hbox'}->pack_start($combo->{'1'},0,0,0);
	$search_win->{'hbox2'} = new Gtk2::HBox(0,5);
	$search_win->{'hbox2'}->show;
	$search_win->{'hbox2'}->pack_start($search_win->{'for'},0,0,0);
	$search_win->{'hbox2'}->pack_start($search_win->{'entry'},0,0,0);
	$search_win->{'vbox'}->pack_start($search_win->{'hbox2'},0,0,0);
	$search_win->{'andorbox'} = new Gtk2::HBox(0,5);
	$search_win->{'andorbox'}->show;
	$search_win->{'vbox'}->pack_start($search_win->{'andorbox'},0,0,0);
	$search_win->{'andorbox'}->pack_start($search_win->{'chk1'},0,0,0);
	$search_win->{'andorbox'}->pack_start($search_win->{'and'},0,0,0);
	$search_win->{'andorbox'}->pack_start($search_win->{'chk2'},0,0,0);
	$search_win->{'andorbox'}->pack_start($search_win->{'or'},0,0,0);
	$search_win->{'andorbox'}->pack_start($combo->{'2'},0,0,0);
	$search_win->{'entry2box'} = new Gtk2::HBox(0,5);
        $search_win->{'entry2box'}->show;
	$search_win->{'vbox'}->pack_start($search_win->{'entry2box'},0,0,0);
	$search_win->{'entry2box'}->pack_start($search_win->{'for2'},0,0,0);
	$search_win->{'entry2box'}->pack_start($search_win->{'entry2'},0,0,0);
	$search_win->{'entry2box'}->pack_start($combo->{'3'},0,0,0);
	$search_win->{'hbox3'}=new Gtk2::HBox(0,5);
	$search_win->{'hbox3'}->show;
	$search_win->{'hbox3'}->pack_start($search_win->{'limitlbl'},0,0,0);
	$search_win->{'hbox3'}->pack_start($search_win->{'limit'},0,0,0);
	$search_win->{'vbox'}->pack_start($search_win->{'hbox3'},0,0,0);
	$search_win->{'hbox4'} = new Gtk2::HBox(0,5);
	$search_win->{'hbox4'}->show;
	$search_win->{'vbox'}->pack_start($search_win->{'hbox4'},0,0,0);
	$search_win->{'hbox4'}->pack_start($search_win->{'body'},0,0,0);
	$search_win->{'hbox4'}->pack_start($search_win->{'bodylabel'},0,0,0);
	$search_win->{'hbox4'}->pack_start($search_win->{'bodytext'},0,0,0);
	$search_win->{'hbox5'} = new Gtk2::HBox(0,5);
	$search_win->{'hbox5'}->show;
	$search_win->{'hbox5'}->pack_start($search_win->{'button'},1,1,0);
	$search_win->{'hbox5'}->pack_start($search_win->{'save'},1,1,0);	
	$search_win->{'vbox'}->pack_start($search_win->{'hbox5'},0,0,0);
}



sub do_search {
	
	my $widget = shift;
	my ($search_win, $combo) = @{shift(@_)};
	my ($entry,$select,$limit,@field);
	my ($sql, $query, $box, @selection, $row, @msg_sel, %selected, $background, $style);
	unless ($combo->{'1'}->entry->get_text eq "All") {
		$entry = $search_win->{'entry'}->get_text;
		if ($entry eq "") { &main::err_dialog(_("Please type something in the entry box")); return 1;}
		if ($search_win->{'chk1'}->get_active or $search_win->{'chk2'}->get_active) {
			if ($combo->{'2'}->entry->get_text ne "BoxName" and $search_win->{'entry2'}->get_text eq "") { 
       		   		&main::err_dialog(_("Please type something in the and/or condition box or uncheck it !"));
		   		return 1;
			}
		}
		if ($search_win->{'body'}->get_active == 1 and $search_win->{'bodytext'}->get_text eq "") {
	      		&main::err_dialog(_("Enter some text in the body search entry"));
			return 1;
		 }

		$select = $combo->{'1'}->entry->get_text;
		$select = lc($select);
		$limit = $search_win->{'limit'}->entry->get_text;
		$box =  &Pronto::FolderTree::get_folder_id();
	 
     	}
	 
	if (!$box or $box !=1000) {
#     	  	$main::folder_tree->select($main::ft_node[1000]);
     	  	$main::folder_tree->get_selection->select_iter($main::ft_node[1000]);
	  	$main::root_window->{'button'}->show;
        }
				 
#	$main::message_clist->freeze;
	$row=0;
#	$main::message_clist->clear;
	
	${$main::message_clist->{'labels'}}[4] = "From";
		if ($combo->{'1'}->entry->get_text eq "All") {
			if ($main::prefs{'messageview'} eq "clist") {
				$sql = "select id,friendly,subject,date,newmsg,localdate,contenttype,priority,replyf,score from messages";
			} elsif ($main::prefs{'messageview'} eq "ctree") {
				$sql = "select msgid,inreplyto,subject,friendly,localdate,id,newmsg,replyf,priority,contenttype,score,ref from messages order by localdate";
			}
		}
		unless ($combo->{'1'}->entry->get_text eq "All") {
			if ($limit eq "Unlimited") { 
				if ($main::prefs{'messageview'} eq "clist") {
					$sql = "select id,friendly,subject,date,newmsg,localdate,contenttype,priority,replyf,score,serverstat from messages where $select like '$entry%'";
				} elsif ($main::prefs{'messageview'} eq "ctree") {
					$sql = "select msgid,inreplyto,subject,friendly,localdate,id,newmsg,replyf,priority,contenttype,score,ref,serverstat from messages where $select like '$entry%' order by localdate";
				}
			} else {
				if ($main::prefs{'messageview'} eq "clist") {
					$sql = "select id,friendly,subject,date,newmsg,localdate,contenttype,priority,replyf,score,serverstat from messages where $select like '$entry%' limit $limit";
              			} elsif ($main::prefs{'messageview'} eq "ctree") {
					$sql = "select msgid,inreplyto,subject,friendly,localdate,id,newmsg,replyf,priority,contenttype,score,ref,serverstat from messages where $select like '$entry%' order by localdate limit $limit";
				}
			}
	 	}
       
	

	if ($search_win->{'chk1'}->get_active) {
		my $fromcombo = $combo->{'2'}->entry->get_text;
		if ($fromcombo ne "BoxName") { 
			$fromcombo = lc($fromcombo);  
			my $condentry = $search_win->{'entry2'}->get_text;
			if ($combo->{'1'}->entry->get_text ne "All"){
			        $sql = $sql . " and $fromcombo like '$condentry%'";
			} else {
			        $sql = $sql . " where $fromcombo like '$condentry%'";
			}	
	
		} else {
       	
			my $boxname = $combo->{'3'}->entry->get_text;
			if ($combo->{'1'}->entry->get_text ne "All"){
			        $sql = $sql . " and boxid =  " .  $main::foldernametoid{$boxname};
			} else {
			        $sql = $sql . " where boxid = " . $main::foldernametoid{$boxname};
			}	
		}
	
		if ($main::prefs{'messageview'} eq "ctree") { $sql =~ s/order by localdate//; $sql = $sql . " order by localdate";}
		if ($search_win->{'limit'}->entry->get_text ne "Unlimited") { $sql =~ s/limit $limit//; $sql = $sql . " limit $limit" }
	}
	
	if ($search_win->{'chk2'}->get_active) {
		my $fromcombo = $combo->{'2'}->entry->get_text;
		if ($fromcombo ne "BoxName") { 
			$fromcombo = lc($fromcombo);  
			my $condentry = $search_win->{'entry2'}->get_text;
       			if ($combo->{'1'}->entry->get_text ne "All"){
			        $sql = $sql . " or $fromcombo like '$condentry%'";
			} else {
			        $sql = $sql . " where $fromcombo like '$condentry%'";
			}	
		} else {
			my $boxname = $combo->{'3'}->entry->get_text;
			if ($combo->{'1'}->entry->get_text ne "All"){
			        $sql = $sql . " or boxid =  " . $main::foldernametoid{$boxname};
			} else {
       			        $sql = $sql . " where boxid = " . $main::foldernametoid{$boxname};
			}
		}	
		if ($main::prefs{'messageview'} eq "ctree") { $sql =~ s/order by localdate//; $sql = $sql . " order by localdate";}
		if ($search_win->{'limit'}->entry->get_text ne "Unlimited") { $sql =~ s/limit $limit//; $sql = $sql . " limit $limit" }
	}

	# The search expression is now assembled in $sql.

	$sql =~ s/^.* from messages where /select msgid,inreplyto,subject,friendly,localdate,id,newmsg,replyf,priority,contenttype,score,ref,serverstat from messages where /i;
	
#	&main::set_labels($main::message_clist);
	$query = $main::conn->prepare($sql);
	$query->execute();
	
	my $rows = $query->rows;
	if ($rows == 0) { &main::err_dialog(_("Your search returned no results!")); }
	if ($search_win->{'body'}->get_active == 0) { 
		$main::folder_tree->get_model->set($main::ft_node[1000], 1, $rows);
	} 
	
	my $i=0;
	my $new = 0;
	my $count = 0;
	my $body = $search_win->{'bodytext'}->get_text;
	$model = $main::message_clist->get_model;
	my %nodes = ();
	my $noderef = \%nodes;
	$model->clear;
	while (my @row = $query->fetchrow_array()) {
		my $id = $row[5];

		if ($stop) { undef $stop; undef $progress; last; }		
		if ($body ne  "") {
			if (not defined $progress && !$stop) { progress() }
			$progress->{'bar'}->set_fraction($count/$rows) if defined $progress;
			my $add = 0;
			my $io = &Pronto::Data::Message::get_source_io_handle($id);
			while ( $_ = $io->getline() ) {
				if (/$body/i) { $add = 1; $count++; last;}
				while (Gtk2->events_pending) { Gtk2->main_iteration }
			}
	
			if ($add != 1) { $io->close(); next }
			$io->close();
		}
		($iter, $noderef) = &Pronto::MessageList::append_message_to_messagelist($noderef, @row);
	}
	
	if ($main::prefs{'threadpref'} eq "expanded") { $main::message_clist->expand_all; }
		else { $main::message_clist->collapse_all; }
	
#	@msg_sel = $main::message_clist->selection;
	if (@msg_sel) {
#		if ($main::prefs{'messageview'} eq "clist") {
#			$main::message_clist->moveto($msg_sel[0],0,'0.5','0.5');
#			$main::message_clist->set_focus_row($msg_sel[0]);
#		}
	}	
	if ($toselect) { #node	
#     		$main::message_clist->node_moveto($toselect,2,0.5,0.5);
#		my $row = $main::message_clist->get_node_position($toselect);
#     		if ($row != -1) {
#  			Gtk2::CList::select_row($main::message_clist,$row,1);
#      			Gtk2::CList::set_focus_row($main::message_clist,$row);
#	       	}
       	
	}
	if ($vpos) {
#		$main::root_window->{'sw'}->set_vadjustment($vpos);
	}	
	if (defined $progress) { 
#		$progress->signal_handlers_destroy();
		$progress->destroy; 
		undef $progress; 
       	}
	if ($body eq "") {
		$main::folder_tree->get_model->set($main::ft_node[1000], 1, $rows);
		$main::folder_tree->get_model->set($main::ft_node[1000], 2, $new);
	}
	if ($count > 0) {
		$main::folder_tree->get_model->set($main::ft_node[1000], 1, $count);
		$main::folder_tree->get_model->set($main::ft_node[1000], 2, $new);
	}
	&main::set_win_title;
	return 1;
}

sub view_virtual_folder {
	my ($vfolder) = @_;	
	my ($body,$sql, $query, $box, @selection, $row, @msg_sel, $background, $style, $toselect, $vpos, $model, $iter);
	my $msg = &Pronto::MessageList::get_selected_msgid();
       	if ($msg) { 
#		$selected{$msg} = 1; 
#      		$vpos = $main::root_window->{'sw'}->get_vadjustment if $main::HTMLWIDGET ne "XmHTML";
	}
	$row=0;
        		
	$main::message_clist->get_column(FROM_COL)->set('title', _("From"));
	if ($main::root_window->{'button'}->visible()) { $main::root_window->{'button'}->hide(); }	
	$sql = "select query,body from boxlist where id = '$vfolder'";
	
	$query = $main::conn->prepare($sql);
	$query->execute();
	($sql,$body) = $query->fetchrow_array();
	
	# convert from default clist query to a new standard query. Florian.
	$sql =~ s/^.* from messages where /select msgid,inreplyto,subject,friendly,localdate,id,newmsg,replyf,priority,contenttype,score,ref,serverstat from messages where /i;
        
	$query = $main::conn->prepare($sql);
	$query->execute();
	my $rows = $query->rows;
	my $i=0;
	my $new = 0;
	my $count = 0;
	$model = $main::message_clist->get_model;
	my %nodes = ();
	my $noderef = \%nodes;
	$model->clear;
	while (my @row = $query->fetchrow_array()) {
		my $id = $row[5];

		if ($stop) { undef $stop; undef $progress; last; }		
		if ($body ne  "") {
			if (not defined $progress && !$stop) { progress() }
			$progress->{'bar'}->set_fraction($count/$rows) if defined $progress;
			my $add = 0;
			my $io = &Pronto::Data::Message::get_source_io_handle($id);
			while ( $_ = $io->getline() ) {
				if (/$body/i) { $add = 1; $count++; last;}
				while (Gtk2->events_pending) { Gtk2->main_iteration }
			}
	
			if ($add != 1) { $io->close(); next }
			$io->close();
		}
		($iter, $noderef) = &Pronto::MessageList::append_message_to_messagelist($noderef, @row);
	}
	
	if ($main::prefs{'threadpref'} eq "expanded") { $main::message_clist->expand_all; }
		else { $main::message_clist->collapse_all; }
	
#	@msg_sel = $main::message_clist->selection;
	if (@msg_sel) {
#		if ($main::prefs{'messageview'} eq "clist") {
#			$main::message_clist->moveto($msg_sel[0],0,'0.5','0.5');
#			$main::message_clist->set_focus_row($msg_sel[0]);
#		}
	}	
	if (($toselect) && ($main::message_clist->iter_is_valid($toselect))) { #node	
		$main::message_clist->get_selection->select_iter($toselect);
		my $path = $main::message_clist->get_selection->get_selected_rows;
		$main::message_clist->expand_row($path, 1);
		$main::message_clist->scroll_to_cell($path, undef, 1, 0.5, 0.5);
		&main::selection_handler($main::message_clist, [$main::root_window->{'html_view'}, $main::attach_menu, $main::view_attach_menu, $main::root_window->{'table1'}]);
	}
	if ($vpos) {
#		$main::root_window->{'sw'}->set_vadjustment($vpos);
	}	
	if (defined $progress) { 
#		$progress->signal_handlers_destroy();
		$progress->destroy; 
		undef $progress; 
       	}
	if ($body eq "") {
		$main::folder_tree->get_model->set($main::ft_node[$vfolder], 1, $rows);
		$main::folder_tree->get_model->set($main::ft_node[$vfolder], 2, $new);
	}
	if ($count > 0) {
		$main::folder_tree->get_model->set($main::ft_node[$vfolder], 1, $count);
		$main::folder_tree->get_model->set($main::ft_node[$vfolder], 2, $new);
	}
	&main::set_win_title;
	return 1;
}

sub save_vf {	
	my $widget = shift;
	my ($search_win,$combo) = @{shift(@_)};
 	my ($entry,$select,$body,$limit,$sql);
	unless ($combo->{'1'}->entry->get_text eq "All") {
 		$entry = $search_win->{'entry'}->get_text;
        	if ($entry eq "") { &main::err_dialog(_("Please type something in the entry box")); return 1;}
		if ($search_win->{'chk1'}->get_active or $search_win->{'chk2'}->get_active) { 
       	   		if ($combo->{'2'}->entry->get_text ne "BoxName" and $search_win->{'entry2'}->get_text eq "") { 
	   		&main::err_dialog(_("Please type something in the and/or condition box or uncheck it !"));
      	   		return 1;		  
                	}
	 	}
		if ($search_win->{'body'}->get_active == 1 and $search_win->{'bodytext'}->get_text eq "") {
			&main::err_dialog(_("Enter some text in the body search entry"));
			return 1;
		}
	}
	$select = $combo->{'1'}->entry->get_text;
	$select = lc($select);
	$limit = $search_win->{'limit'}->entry->get_text;
														  
	if ($combo->{'1'}->entry->get_text eq "All") {
 		$sql = "select id,friendly,subject,date,newmsg,localdate,contenttype,priority,replyf,score,serverstat from messages";
	}
	unless ($combo->{'1'}->entry->get_text eq "All") {
		if ($limit eq "Unlimited") {
			$sql = "select id,friendly,subject,date,newmsg,localdate,contenttype,priority,replyf,score,serverstat from messages where $select like '$entry%'";
		} else {
			$sql = "select id,friendly,subject,date,newmsg,localdate,contenttype,priority,replyf,score,serverstat from messages where $select like '$entry%' limit $limit";
		}
   	}
  
  
  	if ($search_win->{'chk1'}->get_active) {
		my $fromcombo = $combo->{'2'}->entry->get_text;
		if ($fromcombo ne "BoxName") { 
			$fromcombo = lc($fromcombo);  
			my $condentry = $search_win->{'entry2'}->get_text;
       			if ($combo->{'1'}->entry->get_text ne "All"){
			       $sql = $sql . " and $fromcombo like '$condentry%'";
			} else {
			       $sql = $sql . " where $fromcombo like '$condentry%'";
			}       
		} else {
       	
			my $boxname = $combo->{'3'}->entry->get_text;
			if ($combo->{'1'}->entry->get_text ne "All"){
			       $sql = $sql . " and boxid =  " .  $main::foldernametoid{$boxname};
			} else {
			       $sql = $sql . " where boxid = " . $main::foldernametoid{$boxname};
	  	
		        }
		}	
       if ($search_win->{'limit'}->entry->get_text ne "Unlimited") { $sql =~ s/limit $limit//; $sql = $sql . " limit $limit" }  
	}
	
       if ($search_win->{'chk2'}->get_active) {
		my $fromcombo = $combo->{'2'}->entry->get_text;
		if ($fromcombo ne "BoxName") { 
			$fromcombo = lc($fromcombo);  
			my $condentry = $search_win->{'entry2'}->get_text;
       			if ($combo->{'1'}->entry->get_text ne "All"){
			       $sql = $sql . " or $fromcombo like '$condentry%'";
			} else {
			       $sql = $sql . " where $fromcombo like '$condentry%'";
			}       
		} else {
       	
			my $boxname = $combo->{'3'}->entry->get_text;
			if ($combo->{'1'}->entry->get_text ne "All"){
			       $sql = $sql . " or boxid =  " . $main::foldernametoid{$boxname};
			} else {
			       $sql = $sql . " where boxid = " . $main::foldernametoid{$boxname};
			}       
	  	}
    	
	if ($search_win->{'limit'}->entry->get_text ne "Unlimited") { $sql =~ s/limit $limit//; $sql = $sql . " limit $limit" }  
       	
	}
  
  	if ($search_win->{'body'}->get_active and $search_win->{'bodytext'} ne "") {
        	$body = $search_win->{'bodytext'}->get_text;
   	} else { 
		$body = "";
	}


	&Pronto::FolderTree::new_folder("y",$sql,$body);
	return 1;
}	

sub progress
{
	$progress = new Gtk2::Dialog();
	$progress->set_modal(1);
	$progress->set_position(-mouse);
#	$progress->signal_connect("destroy" => \&progress);
	$progress->signal_connect("destroy", sub { $stop = 1;undef $progress;});
	$progress->set_title(_("Searching..."));
	$progress->{'bar'} = new Gtk2::ProgressBar();	
	$progress->{'stop'} = Gtk2::Button->new_from_stock('gtk-stop');
	$progress->{'stop'}->signal_connect("clicked", sub { $progress->destroy; });	
	$progress->vbox->pack_start($progress->{'bar'},1,1,0);
	$progress->action_area->pack_start($progress->{'stop'},1,1,0);
	show_all $progress;	
	while (Gtk2->events_pending) { Gtk2->main_iteration }
}	
1;
