# $Id: Send.pm,v 1.5 2002/05/11 09:55:50 muhri Exp $
# -*- perl -*-
package Pronto::Send;
use SelfLoader;
use vars qw( $inter $called_from_send);
use strict;
use Pronto::Data::Message;
1;
__DATA__

sub send 
{
	if ($called_from_send == 1 and $inter ==1)
	{
		use Gtk2 '-init';
	}	
  
	#touch lock file
	open(TMP,">$main::prefs{'MailDir'}/prontosend.running");
	print TMP "$$\n";
	close(TMP);

	use IO::Socket;
	use Sys::Hostname;
	use Text::ParseWords;
	use MIME::Base64;
	use Pronto::Crypt::Digest_HMAC_MD5::HMAC_MD5 qw(hmac_md5_hex);

	my ($sql, $query, @row, $sql2, $query2, $smtp, @test, $tmp, @body, $sender, $msg, $mailline);
	my ($esmtp, $smtp_server, $username, $password, $base64_username, $base64_password);
	my ($cram_avail, $cram_stamp);
	my $crlf="\r\n";


	$sql = "select id, accountid, sentto, sentfrom, subject, replyto, cc, bcc from messages where boxid = ?";
	$query = $main::conn->prepare($sql);
	$query->execute(2);
	while (@row=$query->fetchrow_array()) {
		my ($msgid, $acctid, $to, $from, $subj, $reply, $cc, $bcc) = @row;
		my $port;
		$sql2 = "select smtp, uname, pass from accounts where id = ?";
		$query2=$main::conn->prepare($sql2);
		$query2->execute($acctid);
		# $username and $password are for ESMTP/SASL uses
		($smtp, $username, $password) = $query2->fetchrow_array();
		$smtp_server = $smtp;
		if ($smtp =~ /^esmtp:\/\//) {
			($esmtp,$smtp) = split(/:\/\//, $smtp);
		}
		($smtp, $port) = split(/:/, $smtp);
		if (!$port || $port eq "") { $port = 25; };
		if (!$main::prefs{'use_http_proxy'}) {
			@test = gethostbyname($smtp);# or next;
			if (!@test) { 
			#       if ($inter == 1) {
			#		&main::err_dialog("SMTP error: Could not resolve hostname $smtp","y");
			#	}
				print(_("SMTP error: Could not resolve hostname ")."$smtp\n");
				next;
			}
		}
		if ($called_from_send == 0) {
			while (Gtk2->events_pending) { Gtk2->main_iteration }
		}
		#get the body
		@body = &Pronto::Data::Message::get_source($msgid);
		# open connection to the smtp server
		if (!$main::prefs{'use_http_proxy'}) {
			$sender=IO::Socket::INET->new( PeerAddr => $smtp,
							PeerPort => $port,
							Proto => 'tcp',
							Timeout=>60);
		} else {
			$sender = IO::Socket::INET->new( PeerAddr => $main::prefs{'Proxy'},
							PeerPort=> $main::prefs{'ProxyPort'},
							Proto => "tcp",
							Type => SOCK_STREAM);
			print $sender "connect $smtp:$port http/1.0\r\n\r\n";
			my $string = <$sender>;
			chomp($string);
			my ($proxy_status) = (split (/ /, $string))[1];
			if (int ($proxy_status /100) != 2) {
				if ($inter == 1) {
					&main::err_dialog("recieved bad status code \"$proxy_status\" from http-proxy while connecting to $smtp","y");
				} else {
					print("recieved bad status code \"$proxy_status\" from http-proxy while connecting to $smtp\n");
				}
				next;
			}
			my $test_int=0;
			while (!$test_int) {
				$string=<$sender>;
				if ($string eq "\n") { $test_int=1; }
			}
		}
		
		
		$msg=$sender->getline() if ($sender);
		if (!$msg) {  
			if ($inter == 1) {
				&main::err_dialog(_("FATAL: An error occured while connecting to ")."$smtp","y");
			}
			print(_("FATAL: An error occured while connecting to ")."$smtp\n");
			last;
		}	
		if ($called_from_send == 0) {
			while (Gtk2->events_pending) { Gtk2->main_iteration }
		}
		if($msg=~/^[45](.*)/){
			if ($inter == 1) { 
				&main::err_dialog("$smtp error: smtp error $1","y") 
			}
			print "$smtp error: smtp error $1\n";
			next;
		}
		$esmtp = $smtp_server;
		if ($esmtp =~ /^esmtp:\/\//){
			#
			# Begin ESMTP handshake
			#

			# Send initial EHLO
			$sender->send("EHLO ".hostname().$crlf);
#print ">>> EHLO ".hostname().$crlf;
			if ($called_from_send == 0) {
				while (Gtk2->events_pending) { Gtk2->main_interaction }
			}

			# Read lines until received a "^250 .*$" and check
			# whether CRAM-MD5 auth is available
			$cram_avail = 0;
			$msg=$sender->getline();
#print "<<< $msg";
			if($msg=~/^[45](.*)/){
				if ($inter == 1) { 
					&main::err_dialog("$smtp error: ESMTP error $1","y") 
				}
				print "$smtp error: ESMTP error $1\n";
				next;
			}
			while ($msg =~ /^250-/) {
				if ($msg =~ /CRAM-MD5/) {
					$cram_avail = 1;
				}
				if ($called_from_send == 0) {
					while (Gtk2->events_pending) { Gtk2->main_interaction }
				}
				$msg=$sender->getline();
#print "<<< $msg";
			}

			if ($cram_avail) {
				#
				# cram-md5 authentication
				#			
				# for information see: 
				# http://fiatlux.zeitform.info/technische_infos/e-mail_prot.html
				#

				# Send wish for cram-md5 login
				$sender->send("AUTH CRAM-MD5".$crlf);
#print ">>> AUTH CRAM-MD5".$crlf;
				if ($called_from_send == 0) {
					while (Gtk2->events_pending) { Gtk2->main_interaction }
				}
				$msg=$sender->getline();
#print "<<< $msg";

				# Send md5 login
				if (not ($msg =~ /^334 (.*)/)){
					if ($inter == 1) { 
						&main::err_dialog("$smtp error: ESMTP CRAM-MD5 error $1","y") 
					}
					print "$smtp error: ESMTP CRAM-MD5 error $1\n";
					next;
				}
				$msg =~ s/^334 //;	# remove reply number
				chop ($msg);		# remove trailing \n
				chop ($msg);		# remove trailing \r
				$cram_stamp = $msg;

				$msg = encode_base64(
						$username . 
						' ' . 
						hmac_md5_hex(
								decode_base64($cram_stamp),
								$password
							)
						);
				
				chop ($msg);
				$sender->send($msg . $crlf);
#print ">>> ".$msg . $crlf;
			} else {
				#
				# base64 authentication
				#			
				
				# Send wish for plain base64 login
				$sender->send("AUTH LOGIN".$crlf);
#print ">>> AUTH LOGIN". $crlf;
				if ($called_from_send == 0) {
					while (Gtk2->events_pending) { Gtk2->main_interaction }
				}
				$msg=$sender->getline();
#print "<<< $msg";

				# Send base64 encoded username
				$base64_username = encode_base64($username);
				chop ($base64_username);
				$sender->send($base64_username . $crlf);
#print ">>> ".$base64_username . $crlf;
				if ($called_from_send == 0) {
					while(Gtk2->events_pending) { Gtk2->main_interation }
				}
				$msg=$sender->getline();
#print "<<< $msg";

				# Send base64 encoded password
				$base64_password = encode_base64($password);
				chop ($base64_password);
				$sender->send($base64_password . $crlf);
#print ">>> ".$base64_password . $crlf
			}
		}
		else {
			#
			# Begin normal SMTP handshake
			#

			$sender->send("helo ".hostname().$crlf);
		}
		if ($called_from_send == 0) {
			while (Gtk2->events_pending) { Gtk2->main_iteration }
		}
		$msg=$sender->getline();
#print "<<< $msg";
		if($msg=~/^[45](.*)/){
			if ($inter == 1) { 
				&main::err_dialog("$smtp error: smtp error $1","y") 
			}
			print "$smtp error: smtp error $1\n";
			next;
		}

		# send mail from
		$_=$from;
		if (/\<(.*)\>/){
			$from="<$1>";
		} else {
			$from="<".$from.">";
		}
		$from=~s/ //g;

		$sender->send("mail from: ".$from.$crlf);
		$msg=$sender->getline();
		if ($called_from_send == 0) {
			while (Gtk2->events_pending) { Gtk2->main_iteration }
		}
		if($msg=~/^[45](.*)/){
			if ($inter == 1) { 
				&main::err_dialog("$smtp error: smtp error $1","y") 
			}
			print "$smtp error: smtp error $1\n";
			next;
		}
	 # send rcpt to for each mail adress
		foreach (quotewords(", ", 1, $to), quotewords(", ", 1, $cc), quotewords(", ", 1, $bcc)){
		#pull <blah@foo.org> from address, or assume address is in blah@foo.org format and just <> it (ie: if you set address as "Kordik, Steven" <stevek@voila.net> this will pull the <stevek@voila.net> out.. if you set address as stevek@voila.net it will just use that, wrapping it in <>) Obviously, this breaks if the To: line contains invalid addresses... but hey.. we should check for that in pronto send function and popup an &&main::err_dialog() to warn... 
			if (/\<(.*)\>/){
				$_="<$1>";
			} else {
				$_="<$_>";
			}
			s/ //g;
			$sender->send("rcpt to: ".$_.$crlf);
			$msg=$sender->getline();
			if ($called_from_send == 0) {
				while (Gtk2->events_pending) { Gtk2->main_iteration }
			}
			if($msg=~/^[45](.*)/){
				if ($inter == 1) { 
					&main::err_dialog("$smtp error: smtp error $1","y") 
				}
				print "$smtp error: smtp error $1\n";
				next;
			}
		}

		# print beginning of data
		$sender->send("data".$crlf);
		$msg=$sender->getline();
		if ($called_from_send == 0) {
			while (Gtk2->events_pending) { Gtk2->main_iteration }
		}
		if($msg=~/^[45](.*)/){
			if ($inter == 1) { 
				&main::err_dialog("$smtp error: smtp error $1","y") 
			}
			print "$smtp error: smtp error $1\n";
			next;
		}


	 # send the body
		foreach $mailline (@body){
			$mailline=~s/\n/$crlf/g;
			$sender->send($mailline);
			if ($called_from_send == 0) {
				while (Gtk2->events_pending) { Gtk2->main_iteration }
			}
		}

		# print data end (a dot)
		$sender->send($crlf.".".$crlf);
		$msg=$sender->getline();
		if ($called_from_send == 0) {
			while (Gtk2->events_pending) { Gtk2->main_iteration }
		}
		if($msg=~/^[45](.*)/){
			if ($inter == 1) { 
				&main::err_dialog("$smtp error: smtp error $1","y") 
			}
			print "$smtp error: smtp error $1\n";
			next;
		}

		$sender->send("quit".$crlf);
		if ($called_from_send == 0) {
			while (Gtk2->events_pending) { Gtk2->main_iteration }
		}
		$sender->close();

		# Apply the normal filters to the message
		my %filterref = &Pronto::Data::Message::make_filter_hash();
		my ($newfolder,$isnew,$score,$newto,$newsubj,$newfrom,$newcc,$newreplyto) =
			&Pronto::Data::Message::apply_filters("save",3,"n",\%filterref,$acctid,$from,$to,$cc,$subj,undef,"");

		# If the message doesn't go to "Sent Items" the friendly field
		# needs to get changed to the sender address.
		if ($newfolder == 3) {
			$sql2 = "update messages set boxid=? where id = ?";
			$query2=$main::conn->prepare($sql2);
			$query2->execute($newfolder, $msgid);
		} else {
			# get the _full_ from field again
			$sql2 = "select sentfrom from messages where id = ?";
			$query2=$main::conn->prepare($sql2);
			$query2->execute($msgid);
			$newfrom = ($query2->fetchrow_array())[0];
			$from = $newfrom;

			# extract some nice name for the friendly field
			my $result;
			$newfrom =~ /\((.+)\)$/ and $result = $1;
			$newfrom =~ /^(.+) <.+>/ and $result = $1;
			$newfrom =~ /^\"(.+)\"/ and $result = $1;
			if (!$result) { $result = $from; }

			# update everything
			$sql2 = "update messages set boxid=?, friendly=? where id = ?";
			$query2=$main::conn->prepare($sql2);
			$query2->execute($newfolder, $result, $msgid);
		}
	}
	
	if(open(TMP,"<$main::prefs{'MailDir'}/pronto.running")) {
		my $proc = <TMP>;
		close(TMP);
		if(kill(0,$proc)) {
			kill('USR2',$proc);
		}
	}
	unlink("$main::prefs{'MailDir'}/prontosend.running");
	if ($query) {$query->finish;}
	if ($query2) {$query2->finish;}

	if ($called_from_send) {
		$main::conn->disconnect;
	}


}

1;
